diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/antenna/model/angles.cc ns-3.34/src/antenna/model/angles.cc
--- ns-3.33/src/antenna/model/angles.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/antenna/model/angles.cc	2021-07-14 10:31:06.000000000 -0700
@@ -28,27 +28,139 @@
 
 NS_LOG_COMPONENT_DEFINE ("Angles");
 
-double DegreesToRadians (double degrees)
+bool Angles::m_printDeg = false;
+
+const double DEG_TO_RAD = M_PI / 180.0;
+const double RAD_TO_DEG = 180.0 / M_PI;
+
+
+double
+DegreesToRadians (double degrees)
+{
+  return degrees * DEG_TO_RAD;
+}
+
+
+double
+RadiansToDegrees (double radians)
+{
+  return radians * RAD_TO_DEG;
+}
+
+
+std::vector<double>
+DegreesToRadians (const std::vector<double> &degrees)
+{
+  std::vector<double> radians;
+  radians.reserve (degrees.size ());
+  for (size_t i = 0; i < degrees.size (); i++)
+    {
+      radians.push_back (DegreesToRadians (degrees[i]));
+    }
+  return radians;
+
+}
+
+
+std::vector<double>
+RadiansToDegrees (const std::vector<double> &radians)
+{
+  std::vector<double> degrees;
+  degrees.reserve (radians.size ());
+  for (size_t i = 0; i < radians.size (); i++)
+    {
+      degrees.push_back (RadiansToDegrees (radians[i]));
+    }
+  return degrees;
+}
+
+
+double
+WrapTo360 (double a)
 {
-  return degrees * M_PI / 180.0;
+  a = fmod (a, 360);
+  if (a < 0)
+    {
+      a += 360;
+    }
+
+  NS_ASSERT_MSG (0 <= a && a < 360, "Invalid wrap, a=" << a);
+  return a;
+}
+
+
+double
+WrapTo180 (double a)
+{
+  a = fmod (a + 180, 360);
+  if (a < 0)
+    {
+      a += 360;
+    }
+  a -= 180;
 
+  NS_ASSERT_MSG (-180 <= a && a < 180, "Invalid wrap, a=" << a);
+  return a;
 }
 
-double RadiansToDegrees (double radians)
+
+double
+WrapTo2Pi (double a)
 {
-  return radians * 180.0 / M_PI;
+  a = fmod (a, 2 * M_PI);
+  if (a < 0)
+    {
+      a += 2 * M_PI;
+    }
+
+  NS_ASSERT_MSG (0 <= a && a < 2 * M_PI, "Invalid wrap, a=" << a);
+  return a;
 }
 
-std::ostream& operator<< (std::ostream& os, const Angles& a)
+
+double
+WrapToPi (double a)
 {
-  os << "(" << a.phi << ", " << a.theta << ")";
+  a = fmod (a + M_PI, 2 * M_PI);
+  if (a < 0)
+    {
+      a += 2 * M_PI;
+    }
+  a -= M_PI;
+
+  NS_ASSERT_MSG (-M_PI <= a && a < M_PI, "Invalid wrap, a=" << a);
+  return a;
+}
+
+
+std::ostream&
+operator<< (std::ostream& os, const Angles& a)
+{
+  double azim, incl;
+  std::string unit;
+
+  if (a.m_printDeg)
+    {
+      azim = RadiansToDegrees (a.m_azimuth);
+      incl = RadiansToDegrees (a.m_inclination);
+      unit = "deg";
+    }
+  else
+    {
+      azim = a.m_azimuth;
+      incl = a.m_inclination;
+      unit = "rad";
+    }
+
+  os << "(" << azim << ", " << incl << ") " << unit;
   return os;
 }
 
-std::istream &operator >> (std::istream &is, Angles &a)
+std::istream&
+operator>> (std::istream& is, Angles& a)
 {
   char c;
-  is >> a.phi >> c >> a.theta;
+  is >> a.m_azimuth >> c >> a.m_inclination;
   if (c != ':')
     {
       is.setstate (std::ios_base::failbit);
@@ -58,31 +170,98 @@
 
 
 Angles::Angles ()
-  : phi (0),
-    theta (0)
-{
-}
+  : Angles (NAN, NAN)
+{}
 
 
-Angles::Angles (double p, double t)
-  : phi (p),
-    theta (t)
+Angles::Angles (double azimuth, double inclination)
+  : m_azimuth (azimuth),
+    m_inclination (inclination)
 {
+  NormalizeAngles ();
 }
 
 
 Angles::Angles (Vector v)
-  : phi (std::atan2 (v.y, v.x)),
-    theta (std::acos (v.z / v.GetLength ()))
+  : m_azimuth (std::atan2 (v.y, v.x)),
+    m_inclination (std::acos (v.z / v.GetLength ()))
 {
+  // azimuth and inclination angles for zero-length vectors are not defined
+  if (v.x == 0.0 && v.y == 0.0 && v.z == 0.0)
+    {
+      m_azimuth = NAN;
+      m_inclination = NAN;
+    }
+
+  NormalizeAngles ();
 }
 
 Angles::Angles (Vector v, Vector o)
-  : phi (std::atan2 (v.y - o.y, v.x - o.x)),
-    theta (std::acos ((v.z - o.z) / CalculateDistance (v, o)))
+  : Angles (v - o)
+{}
+
+
+
+void
+Angles::SetAzimuth (double azimuth)
 {
+  m_azimuth = azimuth;
+  NormalizeAngles ();
 }
 
 
+void
+Angles::SetInclination (double inclination)
+{
+  m_inclination = inclination;
+  NormalizeAngles ();
+}
+
+
+double
+Angles::GetAzimuth (void) const
+{
+  return m_azimuth;
+}
+
+
+double
+Angles::GetInclination (void) const
+{
+  return m_inclination;
+}
+
+
+void
+Angles::NormalizeAngles (void)
+{
+  CheckIfValid ();
+
+  // Normalize azimuth angle
+  if (std::isnan (m_azimuth))
+    {
+      return;
+    }
+
+  m_azimuth = WrapToPi (m_azimuth);
+}
+
+
+void
+Angles::CheckIfValid (void) const
+{
+  if (std::isfinite (m_inclination) || std::isfinite (m_azimuth))
+    {
+      NS_ASSERT_MSG (0.0 <= m_inclination && m_inclination <= M_PI,
+                     "m_inclination=" << m_inclination << " not valid, should be in [0, pi] rad");
+    }
+  else
+    {
+      // infinite or nan inclination or azimuth angle
+      NS_LOG_WARN ("Undefined angle: " << *this);
+    }
+
+}
+
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/antenna/model/angles.h ns-3.34/src/antenna/model/angles.h
--- ns-3.33/src/antenna/model/angles.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/antenna/model/angles.h	2021-07-14 10:31:06.000000000 -0700
@@ -23,6 +23,7 @@
 
 
 #include <ns3/vector.h>
+#include <vector>
 
 namespace ns3 {
 
@@ -31,63 +32,107 @@
  * \brief converts degrees to radians
  * 
  * \param degrees the angle in degrees
- * 
  * \return the angle in radians
  */
 double DegreesToRadians (double degrees);
 
 /** 
+ * \brief converts degrees to radians
+ * 
+ * \param degrees the angles in degrees
+ * \return the angles in radians
+ */
+std::vector<double> DegreesToRadians (const std::vector<double> &degrees);
+
+/** 
  * \brief converts radians to degrees
  * 
  * \param radians the angle in radians
- * 
  * \return the angle in degrees
  */
 double RadiansToDegrees (double radians);
 
 /** 
+ * \brief converts radians to degrees
+ * 
+ * \param radians the angles in radians
+ * \return the angles in degrees
+ */
+std::vector<double> RadiansToDegrees (const std::vector<double> &radians);
+
+/** 
+ * \brief Wrap angle in [0, 360)
+ * 
+ * \param a the angle in degrees
+ * \return the wrapped angle in degrees
+ */
+double WrapTo360 (double a);
+
+/** 
+ * \brief Wrap angle in [-180, 180)
  * 
- * struct holding the azimuth and inclination angles of spherical
- * coordinates. The notation is the one used in  "Antenna Theory - Analysis
- * and Design", C.A. Balanis, Wiley, 2nd Ed., section 2.2 "Radiation
- * pattern".
- * This notation corresponds to the standard spherical coordinates, with phi
+ * \param a the angle in degrees
+ * \return the wrapped angle in degrees
+ */
+double WrapTo180 (double a);
+
+/** 
+ * \brief Wrap angle in [0, 2*M_PI)
+ * 
+ * \param a the angle in radians
+ * \return the wrapped angle in radians
+ */
+double WrapTo2Pi (double a);
+
+/** 
+ * \brief Wrap angle in [-M_PI, M_PI)
+ * 
+ * \param a the angle in radians
+ * \return the wrapped angle in radians
+ */
+double WrapToPi (double a);
+
+/** 
+ * 
+ * Class holding the azimuth and inclination angles of spherical coordinates.
+ * The notation is the one used in  "Antenna Theory - Analysis
+ * and Design", C.A. Balanis, Wiley, 2nd Ed., section 2.2 "Radiation pattern".
+ * This notation corresponds to the standard spherical coordinates, with azimuth
  * measured counterclockwise in the x-y plane off the x-axis, and
- * theta measured off the z-axis. 
+ * inclination measured off the z-axis.
+ * Azimuth is consistently normalized to be in [-M_PI, M_PI).
  * 
  *          ^
  *        z | 
- *          |_ theta
+ *          |_ inclination
  *          | \
  *          | /|
  *          |/ |   y
  *          +-------->
  *         /  \|
  *        /___/
- *     x /  phi
+ *     x /  azimuth
  *      |/
  *
  */
-struct Angles
+class Angles
 {
+public:
   /** 
-   * default constructor, will initialize phi and theta to zero
+   * This constructor allows to specify azimuth and inclination.
+   * Inclination must be in [0, M_PI], while azimuth is
+   * automatically notmalized in [-M_PI, M_PI)
    * 
+   * \param azimuth the azimuth angle in radians
+   * \param inclination the inclination angle in radians
    */
-  Angles ();
+  Angles (double azimuth, double inclination);
 
   /** 
-   * this constructor allows to specify phi and  theta
-   * 
-   * \param phi the azimuth angle in radians
-   * \param theta the inclination angle in radians
-   * 
-   */
-  Angles (double phi, double theta);
-
-  /** 
-   * this constructor will initialize phi and theta by converting the
+   * This constructor will initialize azimuth and inclination by converting the
    * given 3D vector from cartesian coordinates to spherical coordinates
+   * Note: azimuth and inclination angles for a zero-length vector are not defined
+   * and are thus initialized to NAN
    * 
    * \param v the 3D vector in cartesian coordinates
    * 
@@ -95,7 +140,7 @@
   Angles (Vector v);
 
   /** 
-   * this constructor initializes an Angles instance with the angles
+   * This constructor initializes an Angles instance with the angles
    * of the spherical coordinates of point v respect to point o 
    * 
    * \param v the point (in cartesian coordinates) for which the angles are determined
@@ -105,39 +150,68 @@
   Angles (Vector v, Vector o);
 
   /**
-   * the azimuth angle in radians
-   * 
+   * Setter for azimuth angle
+   *
+   * \param azimuth angle in radians
    */
-  double phi;
+  void SetAzimuth (double azimuth);
 
   /**
-   * the inclination angle in radians
-   * 
+   * Setter for inclination angle
+   *
+   * \param inclination angle in radians. Must be in [0, M_PI]
    */
-  double theta;
-};
+  void SetInclination (double inclination);
 
+  /**
+   * Getter for azimuth angle
+   *
+   * \return azimuth angle in radians
+   */
+  double GetAzimuth (void) const;
 
+  /**
+   * Getter for inclination angle
+   *
+   * \return inclination angle in radians
+   */
+  double GetInclination (void) const;
 
-/** 
- * print a struct Angles to output
- * 
- * \param os the output stream
- * \param a the Angles struct
- * 
- * \return a reference to the output stream
- */
-std::ostream& operator<< ( std::ostream& os, const Angles& a);
+  // friend methods
+  friend std::ostream& operator<< (std::ostream& os, const Angles& a);
+  friend std::istream& operator>> (std::istream& is, Angles& a);
+
+  static bool m_printDeg; //!< flag for printing in radians or degrees units
+
+private:
+  /** 
+   * Default constructor is disabled
+   */
+  Angles ();
+
+  /**
+    * Normalize the angle azimuth angle range between in [-M_PI, M_PI)
+    * while checking if the angle is valid, i.e., finite and within
+    * the bounds.
+    * 
+    * Note: while an arbitrary value for the azimuth angle is valid
+    * and can be wrapped in [-M_PI, M_PI), an inclination angle outside
+    * the [0, M_PI] range can be ambiguos and is thus not valid.
+    */
+  void NormalizeAngles (void);
+
+  /**
+    * Check if Angle is valid or not
+    * Warns the user if the Angle is undefined (non-finite azimuth or inclination),
+    * throws an assert if the inclination angle is invalid (not in [0, M_PI])
+    */
+  void CheckIfValid (void) const;
+
+
+  double m_azimuth; //!< the azimuth angle in radians
+  double m_inclination; //!< the inclination angle in radians
+};
 
-/** 
- * initialize a struct Angles from input
- * 
- * \param is the input stream
- * \param a the Angles struct
- * 
- * \return a reference to the input stream
- */
-std::istream &operator >> (std::istream &is, Angles &a);
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/antenna/model/cosine-antenna-model.cc ns-3.34/src/antenna/model/cosine-antenna-model.cc
--- ns-3.33/src/antenna/model/cosine-antenna-model.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/antenna/model/cosine-antenna-model.cc	2021-07-14 10:31:06.000000000 -0700
@@ -34,19 +34,25 @@
 NS_OBJECT_ENSURE_REGISTERED (CosineAntennaModel);
 
 
-TypeId 
+TypeId
 CosineAntennaModel::GetTypeId ()
 {
   static TypeId tid = TypeId ("ns3::CosineAntennaModel")
     .SetParent<AntennaModel> ()
-    .SetGroupName("Antenna")
+    .SetGroupName ("Antenna")
     .AddConstructor<CosineAntennaModel> ()
-    .AddAttribute ("Beamwidth",
-                   "The 3dB beamwidth (degrees)",
-                   DoubleValue (60),
-                   MakeDoubleAccessor (&CosineAntennaModel::SetBeamwidth,
-                                       &CosineAntennaModel::GetBeamwidth),
-                   MakeDoubleChecker<double> (0, 180))
+    .AddAttribute ("VerticalBeamwidth",
+                   "The 3 dB vertical beamwidth (degrees). A beamwidth of 360 deg corresponds to constant gain",
+                   DoubleValue (360),
+                   MakeDoubleAccessor (&CosineAntennaModel::SetVerticalBeamwidth,
+                                       &CosineAntennaModel::GetVerticalBeamwidth),
+                   MakeDoubleChecker<double> (0, 360))
+    .AddAttribute ("HorizontalBeamwidth",
+                   "The 3 dB horizontal beamwidth (degrees). A beamwidth of 360 deg corresponds to constant gain",
+                   DoubleValue (120),
+                   MakeDoubleAccessor (&CosineAntennaModel::SetHorizontalBeamwidth,
+                                       &CosineAntennaModel::GetHorizontalBeamwidth),
+                   MakeDoubleChecker<double> (0, 360))
     .AddAttribute ("Orientation",
                    "The angle (degrees) that expresses the orientation of the antenna on the x-y plane relative to the x axis",
                    DoubleValue (0.0),
@@ -62,67 +68,110 @@
   return tid;
 }
 
-void 
-CosineAntennaModel::SetBeamwidth (double beamwidthDegrees)
-{ 
-  NS_LOG_FUNCTION (this << beamwidthDegrees);
-  m_beamwidthRadians = DegreesToRadians (beamwidthDegrees);
-  m_exponent = -3.0 / (20 * std::log10 (std::cos (m_beamwidthRadians / 4.0)));
-  NS_LOG_LOGIC (this << " m_exponent = " << m_exponent);
+
+double
+CosineAntennaModel::GetExponentFromBeamwidth (double beamwidthDegrees)
+{
+  NS_LOG_FUNCTION (beamwidthDegrees);
+
+  // The formula in obtained by inverting the power pattern P(alpha) in a single direction,
+  // while imposing that P(alpha0/2) = 0.5 = -3 dB, with respect to the exponent
+  // See CosineAntennaModel::GetGainDb for more information.
+  //
+  // The undetermined case of alpha0=360 is treated separately.
+  double exponent;
+  if (beamwidthDegrees == 360.0)
+  {
+    exponent = 0.0;
+  }
+  else
+  {
+    exponent = -3.0 / (20 * std::log10 (std::cos (DegreesToRadians (beamwidthDegrees / 4.0))));
+  }
+
+  return exponent;
 }
 
+
 double
-CosineAntennaModel::GetBeamwidth () const
+CosineAntennaModel::GetBeamwidthFromExponent (double exponent)
+{
+  NS_LOG_FUNCTION (exponent);
+
+  // The formula in obtained by inverting the power pattern P(alpha) in a single direction,
+  // while imposing that P(alpha0/2) = 0.5 = -3 dB, with respect to the beamwidth.
+  // See CosineAntennaModel::GetGainDb for more information.
+  double beamwidthRadians = 4 * std::acos (std::pow (0.5, 1 / (2 * exponent)));
+  return RadiansToDegrees (beamwidthRadians);
+}
+
+
+void
+CosineAntennaModel::SetVerticalBeamwidth (double verticalBeamwidthDegrees)
+{
+  NS_LOG_FUNCTION (this << verticalBeamwidthDegrees);
+  m_verticalExponent = GetExponentFromBeamwidth (verticalBeamwidthDegrees);
+}
+
+
+void
+CosineAntennaModel::SetHorizontalBeamwidth (double horizontalBeamwidthDegrees)
 {
-  return RadiansToDegrees (m_beamwidthRadians);
+  NS_LOG_FUNCTION (this << horizontalBeamwidthDegrees);
+  m_horizontalExponent = GetExponentFromBeamwidth (horizontalBeamwidthDegrees);
 }
 
-void 
+
+double
+CosineAntennaModel::GetVerticalBeamwidth () const
+{
+  return GetBeamwidthFromExponent (m_verticalExponent);
+}
+
+
+double
+CosineAntennaModel::GetHorizontalBeamwidth () const
+{
+  return GetBeamwidthFromExponent (m_horizontalExponent);
+}
+
+
+void
 CosineAntennaModel::SetOrientation (double orientationDegrees)
 {
   NS_LOG_FUNCTION (this << orientationDegrees);
   m_orientationRadians = DegreesToRadians (orientationDegrees);
 }
 
+
 double
 CosineAntennaModel::GetOrientation () const
 {
   return RadiansToDegrees (m_orientationRadians);
 }
 
-double 
+
+double
 CosineAntennaModel::GetGainDb (Angles a)
 {
   NS_LOG_FUNCTION (this << a);
-  // azimuth angle w.r.t. the reference system of the antenna
-  double phi = a.phi - m_orientationRadians;
 
   // make sure phi is in (-pi, pi]
-  while (phi <= -M_PI)
-    {
-      phi += M_PI+M_PI;
-    }
-  while (phi > M_PI)
-    {
-      phi -= M_PI+M_PI;
-    }
-
-  NS_LOG_LOGIC ("phi = " << phi );
-
-  // element factor: amplitude gain of a single antenna element in linear units
-  double ef = std::pow (std::cos (phi / 2.0), m_exponent);
-
-  // the array factor is not considered. Note that if we did consider
-  // the array factor, the actual beamwidth would change, and in
-  // particular it would be different from the one specified by the
-  // user. Hence it is not desirable to use the array factor, for the
-  // ease of use of this model.
+  a.SetAzimuth (a.GetAzimuth () - m_orientationRadians);
+
+  NS_LOG_LOGIC (a);
 
-  double gainDb = 20 * std::log10 (ef);
+  // The element power gain is computed as a product of cosine functions on the two axis
+  // The power pattern of the element is equal to:
+  // P(az,el) = cos(az/2)^2m * cos(pi/2 - incl/2)^2n,
+  // where az is the azimuth angle, and incl is the inclination angle.
+  double gain = (std::pow (std::cos (a.GetAzimuth () / 2), 2 * m_horizontalExponent)) *
+                (std::pow (std::cos ((M_PI / 2 - a.GetInclination ()) / 2), 2 * m_verticalExponent));
+  double gainDb = 10 * std::log10 (gain);
+  
   NS_LOG_LOGIC ("gain = " << gainDb << " + " << m_maxGain << " dB");
   return gainDb + m_maxGain;
 }
 
 
 }
-
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/antenna/model/cosine-antenna-model.h ns-3.34/src/antenna/model/cosine-antenna-model.h
--- ns-3.33/src/antenna/model/cosine-antenna-model.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/antenna/model/cosine-antenna-model.h	2021-07-14 10:31:06.000000000 -0700
@@ -28,48 +28,89 @@
 namespace ns3 {
 
 /**
- * 
- * \brief Cosine Antenna Model 
  *
- * This class implements the cosine model as described in:
+ * \brief Cosine Antenna Model
  *
- * Li Chunjian, "Efficient Antenna Patterns for Three-Sector WCDMA Systems"
+ * This class implements the cosine model, similarly to what is described in:
+ * Cosine Antenna Element, Mathworks, Phased Array System Toolbox (Sep. 2020)
+ * Available online: https://www.mathworks.com/help/phased/ug/cosine-antenna-element.html
  *
- * Note that only the element factor of the above model is
- * considered. Also, an additional constant gain is added to model the
- * radiation pattern on the vertical plane (to account for the fact
- * that the elevation angle is not included in the model).
+ * The power pattern of the element is equal to:
+  // P(az,el) = cos(az/2)^2m * cos(pi/2 - incl/2)^2n,
+  // where az is the azimuth angle, and incl is the inclination angle.
+ *
+ * Differently from the source, the response is defined for azimuth and elevation angles
+ * between –180 and 180 degrees and is always positive.
+ * There is no response at the backside of a cosine antenna.
+ * The cosine response pattern achieves a maximum value of 1 (0 dB) at 0 degrees azimuth
+ * and 90 degrees inclination.
+ * An extra settable gain is added to the original model, to improve its generality.
  */
 class CosineAntennaModel : public AntennaModel
 {
 public:
-
   // inherited from Object
   static TypeId GetTypeId ();
 
   // inherited from AntennaModel
   virtual double GetGainDb (Angles a);
 
+  /**
+   * Get the vertical 3 dB beamwidth of the cosine antenna model.
+   * \return the vertical beamwidth in degrees
+   */
+  double GetVerticalBeamwidth (void) const;
 
-  // attribute getters/setters
-  void SetBeamwidth (double beamwidthDegrees);
-  double GetBeamwidth () const;
-  void SetOrientation (double orientationDegrees);
-  double GetOrientation () const;
+  /**
+   * Get the horizontal 3 dB beamwidth of the cosine antenna model.
+   * \return the horizontal beamwidth in degrees
+   */
+  double GetHorizontalBeamwidth (void) const;
+
+  /**
+   * Get the horizontal orientation of the antenna element.
+   * \return the horizontal orientation in degrees
+   */
+  double GetOrientation (void) const;
 
 private:
 
   /**
-   * this is the variable "n" in the paper by Chunjian
-   * 
+   * Set the vertical 3 dB beamwidth (bilateral) of the cosine antenna model.
+   * \param verticalBeamwidthDegrees the vertical beamwidth in degrees
    */
-  double m_exponent; 
+  void SetVerticalBeamwidth (double verticalBeamwidthDegrees);
 
-  double m_beamwidthRadians;
+  /**
+   * Set the horizontal 3 dB beamwidth (bilateral) of the cosine antenna model.
+   * \param horizontalBeamwidthDegrees the horizontal beamwidth in degrees
+   */
+  void SetHorizontalBeamwidth (double horizontalBeamwidthDegrees);
+
+  /**
+   * Set the horizontal orientation of the antenna element.
+   * \param orientationDegrees the horizontal orientation in degrees
+   */
+  void SetOrientation (double orientationDegrees);
 
-  double m_orientationRadians;
+  /**
+   * Compute the exponent of the cosine antenna model from the beamwidth
+   * \param beamwidthRadians the beamwidth in degrees
+   * \return the exponent
+   */
+  static double GetExponentFromBeamwidth (double beamwidthDegrees);
+  
+  /**
+   * Compute the beamwidth of the cosine antenna model from the exponent
+   * \param exponent the exponent
+   * \return beamwidth in degrees
+   */
+  static double GetBeamwidthFromExponent (double exponent);
 
-  double m_maxGain;
+  double m_verticalExponent;            //!< exponent of the vertical direction
+  double m_horizontalExponent;          //!< exponent of the horizontal direction
+  double m_orientationRadians;          //!< orientation in radians in the horizontal direction (bearing)
+  double m_maxGain;                     //!< antenna gain in dB towards the main orientation
 };
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/antenna/model/parabolic-antenna-model.cc ns-3.34/src/antenna/model/parabolic-antenna-model.cc
--- ns-3.33/src/antenna/model/parabolic-antenna-model.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/antenna/model/parabolic-antenna-model.cc	2021-07-14 10:31:06.000000000 -0700
@@ -93,7 +93,7 @@
 {
   NS_LOG_FUNCTION (this << a);
   // azimuth angle w.r.t. the reference system of the antenna
-  double phi = a.phi - m_orientationRadians;
+  double phi = a.GetAzimuth () - m_orientationRadians;
 
   // make sure phi is in (-pi, pi]
   while (phi <= -M_PI)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/antenna/model/phased-array-model.cc ns-3.34/src/antenna/model/phased-array-model.cc
--- ns-3.33/src/antenna/model/phased-array-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/antenna/model/phased-array-model.cc	2021-07-14 10:31:06.000000000 -0700
@@ -0,0 +1,169 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+*   Copyright (c) 2020 University of Padova, Dep. of Information Engineering, SIGNET lab.
+*
+*   This program is free software; you can redistribute it and/or modify
+*   it under the terms of the GNU General Public License version 2 as
+*   published by the Free Software Foundation;
+*
+*   This program is distributed in the hope that it will be useful,
+*   but WITHOUT ANY WARRANTY; without even the implied warranty of
+*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*   GNU General Public License for more details.
+*
+*   You should have received a copy of the GNU General Public License
+*   along with this program; if not, write to the Free Software
+*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#include "phased-array-model.h"
+#include <ns3/isotropic-antenna-model.h>
+#include <ns3/log.h>
+#include <ns3/double.h>
+#include <ns3/uinteger.h>
+#include <ns3/boolean.h>
+#include <ns3/pointer.h>
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("PhasedArrayModel");
+
+NS_OBJECT_ENSURE_REGISTERED (PhasedArrayModel);
+
+std::ostream&
+operator<< (std::ostream& os, const PhasedArrayModel::ComplexVector& cv)
+{
+  size_t N = cv.size ();
+
+  // empty
+  if (N == 0)
+    {
+      os << "[]";
+      return os;
+    }
+
+  // non-empty
+  os << "[";
+  for (std::size_t i = 0; i < N - 1; ++i)
+    {
+      os << cv[i] << ", ";
+    }
+  os << cv[N - 1] << "]";
+  return os;
+}
+
+PhasedArrayModel::PhasedArrayModel ()
+  : m_isBfVectorValid {false}
+{}
+
+
+PhasedArrayModel::~PhasedArrayModel ()
+{
+  m_beamformingVector.clear ();
+}
+
+
+TypeId
+PhasedArrayModel::GetTypeId ()
+{
+  static TypeId tid = TypeId ("ns3::PhasedArrayModel")
+    .SetParent<Object> ()
+    .SetGroupName ("Antenna")
+    .AddAttribute ("AntennaElement",
+                   "A pointer to the antenna element used by the phased array",
+                   PointerValue (CreateObject<IsotropicAntennaModel> ()),
+                   MakePointerAccessor (&PhasedArrayModel::m_antennaElement),
+                   MakePointerChecker<AntennaModel> ())
+  ;
+  return tid;
+}
+
+
+void
+PhasedArrayModel::SetBeamformingVector (const ComplexVector &beamformingVector)
+{
+  NS_LOG_FUNCTION (this << beamformingVector);
+  NS_ASSERT_MSG (beamformingVector.size () == GetNumberOfElements (),
+                 beamformingVector.size () << " != " << GetNumberOfElements ());
+  m_beamformingVector = beamformingVector;
+  m_isBfVectorValid = true;
+}
+
+
+PhasedArrayModel::ComplexVector
+PhasedArrayModel::GetBeamformingVector () const
+{
+  NS_LOG_FUNCTION (this);
+  NS_ASSERT_MSG (m_isBfVectorValid, "The beamforming vector should be Set before it's Get, and should refer to the current array configuration");
+  return m_beamformingVector;
+}
+
+
+double
+PhasedArrayModel::ComputeNorm (const ComplexVector &vector)
+{
+  double norm = 0;
+
+  for (uint64_t i = 0; i < vector.size (); i++)
+    {
+      norm += std::norm (vector[i]);
+    }
+
+  return std::sqrt (norm);
+
+}
+
+
+PhasedArrayModel::ComplexVector
+PhasedArrayModel::GetBeamformingVector (Angles a) const
+{
+  NS_LOG_FUNCTION (this << a);
+
+  ComplexVector beamformingVector = GetSteeringVector (a);
+  double norm = ComputeNorm (beamformingVector);
+
+  for (uint64_t i = 0; i < beamformingVector.size (); i++)
+    {
+      beamformingVector[i] = std::conj (beamformingVector[i]) / norm;
+    }
+
+  return beamformingVector;
+}
+
+
+
+PhasedArrayModel::ComplexVector
+PhasedArrayModel::GetSteeringVector (Angles a) const
+{
+  ComplexVector steeringVector;
+  steeringVector.resize (GetNumberOfElements ());
+  for (uint64_t i = 0; i < GetNumberOfElements (); i++)
+    {
+      Vector loc = GetElementLocation (i);
+      double phase = -2 * M_PI * (sin (a.GetInclination ()) * cos (a.GetAzimuth ()) * loc.x +
+                                  sin (a.GetInclination ()) * sin (a.GetAzimuth ()) * loc.y +
+                                  cos (a.GetInclination ()) * loc.z);
+      steeringVector[i] = std::polar<double> (1.0, phase);
+    }
+  return steeringVector;
+}
+
+
+void
+PhasedArrayModel::SetAntennaElement (Ptr<AntennaModel> antennaElement)
+{
+  NS_LOG_FUNCTION (this);
+  m_antennaElement = antennaElement;
+}
+
+
+Ptr<const AntennaModel>
+PhasedArrayModel::GetAntennaElement () const
+{
+  NS_LOG_FUNCTION (this);
+  return m_antennaElement;
+}
+
+
+} /* namespace ns3 */
+
